<?php

global $mysql_link;  /* fixup for mysqli - global link indentifier */

if (!defined('PRG_DBPERSIST'))
  define('PRG_DBPERSIST','');

if (function_exists('mysqli_connect'))
  define('USE_MYSQLI', true);


function SQL_opendefault() {
  return SQL_open(PRG_DBHOST,PRG_DBPORT,PRG_DBUSER,PRG_DBPASS,PRG_DBNAME,PRG_DBPERSIST);
}

function SQL_open($host,$port,$user,$pass,$name,$persist="") {  
  global $debug;
  $err_link="";
  $err_open="";

  if ($persist)
    $link=@SQL_pconnect($host,$port,$user,$pass);
  else
    $link=@SQL_connect($host,$port,$user,$pass);   

  if (!$link) {
    $err_link=@SQL_error();
    if ($err_link)
      $err_link="MySQL error ".SQL_errno().": ".$err_link."<br/><br/>";
    if (!function_exists('Msg'))
      require_once(PRG_PATH . 'core/msgdlg.php');
    echo "<center>\n";
    MsgFatal(
"Can't contact database; check username, password and MySQL access rights.<br/><br/>".
$err_link.
"This message is displayed when the web part cannot connect into the database ".
"(bad username/password or database server hostname not found or database is ".
"not running). ".

"<ol>\n".
"<li>Check if MySQL server is running. In the Linux environment type the following commands:".

"<pre>ps ax | grep mysql</pre>".

"<pre>mysql -u root -p nfx</pre>".
"<pre>mysql&gt; quit;</pre></li>\n".

"<li>If database is not running type the following command: ".

"<pre>/etc/init.d/mysql start\n-or-\n/etc/init.d/mysqld start</pre></li>\n".


"<li>Check <i>/etc/netflow/nfw.php</i> file and make sure that you have the correct parameters ". 
"for the database connection (username, password, database name is nfx). ".
"Use the following command to view content of the file: ".
"<pre>cat /etc/netflow/nfw.php</pre>".

"To correct database parameters you can use the <i>nf_install</i> utility.</li>\n".


"<li>Based on our PHP knowledge, the PHP module <i>mysql.so</i> is probably compiled with ".
"an old libmysqlclient version 10. There are several recommendations that might help: ".
"Check if your PHP package is the newest version (try upgrading PHP or degrade mysql). ".
"Try restarting Apache web server.</li>\n".

"<li>If you cannot connect into the database due to a wrong password you can ".
"use the password recovery steps (refer to the documentation - appendix 2).</li>\n".
"</ol>"
    );
  }


  $opened=@SQL_select_db($name, $link);
  if (!$opened) {
    $err_open=@SQL_error();
    if ($err_open)
      $err_open="<br/><br/>MySQL error ".SQL_errno().": ".$err_open."<br/><br/>";
    if (!function_exists('Msg'))
      require_once(PRG_PATH . 'core/msgdlg.php');
    echo "<center>\n";
    MsgFatal(
"Can't open database '$name'; check if database exists or you have access rights to use it.<br/><br/>".
$err_open.

"When you ran the <i>nf_install</i> script did you successfully complete step 1? ".
"Step 1 creates database and all system tables. Type the following commands ".
"to check if step 1 was successfully completed: ".

"<pre>mysql -u root -p\nPassword:\n\n".
"mysql&gt; use nfx;\n".
"mysql&gt; show tables;\n".
"mysql&gt; quit;</pre>".

"If software was successfully installed you will see a lot of tables displayed. ".
"If it isn't correctly installed then MySQL will write the following information: ".
"nfx database doesn't exists. In the Debian installation the default password is blank." 

    );

  }
  return $link;
}



function SQL_pconnect($host,$port,$user,$pass) {
  global $mysql_link;

  if (defined('USE_MYSQLI')) {
    if ($port)
      $mysql_link = mysqli_connect('p:'.$host, $user, $pass, '', $port);
    else
      $mysql_link = mysqli_connect('p:'.$host, $user, $pass);
    mysqli_set_charset($mysql_link, 'utf8');
    return $mysql_link;
  }
  return mysql_pconnect(($port)?$host.':'.$port:$host.':3306',$user,$pass);
}

  
function SQL_connect($host,$port,$user,$pass) {
  global $mysql_link;

  if (defined('USE_MYSQLI')) {
    if ($port)
      $mysql_link = mysqli_connect($host, $user, $pass, '', $port);
    else
      $mysql_link = mysqli_connect($host, $user, $pass);
    mysqli_set_charset($mysql_link, 'utf8');
    return $mysql_link;
  }
  return mysql_connect(($port)?$host.':'.$port:$host.':3306',$user,$pass);
}



function SQL_close() {
  global $mysql_link;

  $args=func_get_args();
  if (func_num_args()>0) {    
    if (defined('USE_MYSQLI'))
      return @mysqli_close($args[0]);
    return @mysql_close($args[0]);
  }
  if (defined('USE_MYSQLI'))
    return @mysqli_close($mysql_link);
  return @mysql_close();
}



function SQL_error() {
  global $mysql_link;

  $args=func_get_args();
  if (func_num_args()>0) {
    if (defined('USE_MYSQLI'))
      return mysqli_error($args[0]);
    return mysql_error($args[0]);
  }
  if (defined('USE_MYSQLI'))
    return mysqli_error($mysql_link);
  return mysql_error();
}



function SQL_errno() {
  global $mysql_link;

  $args=func_get_args();
  if (func_num_args()>0) {    
    if (defined('USE_MYSQLI'))
      return mysqli_errno($args[0]);
    return mysql_errno($args[0]);
  }
  if (defined('USE_MYSQLI'))
    return mysqli_errno($mysql_link);
  return mysql_errno();
}



function SQL_select_db($db) {
  global $mysql_link;

  $args=func_get_args();
  if (func_num_args()>1) {
    if (defined('USE_MYSQLI'))
      return mysqli_select_db($args[1], $args[0]);
    return mysql_select_db($args[0], $args[1]);
  }
  if (defined('USE_MYSQLI'))
    return mysqli_select_db($mysql_link, $args[0]);
  return mysql_select_db($args[0]);
}


function SQL_query($query) { 
  global $mysql_link;

  $args=func_get_args();
  if (func_num_args()>1) {
    if (defined('USE_MYSQLI'))
      return mysqli_query($args[1], $args[0]);
    return mysql_query($args[0], $args[1]);
  }
  if (defined('USE_MYSQLI'))
    return mysqli_query($mysql_link, $args[0]);
  return mysql_query($args[0]);
}
    
  
function SQL_free_result($res) {
  if (defined('USE_MYSQLI'))
    return mysqli_free_result($res);
  return mysql_free_result($res);
}
  
  
function SQL_num_rows($res) {
  if (defined('USE_MYSQLI'))
    return mysqli_num_rows($res);
  return mysql_num_rows($res);
}
    
  
function SQL_fetch_array($res) {
  if (defined('USE_MYSQLI'))
    return mysqli_fetch_array($res);
  return mysql_fetch_array($res);
}


function SQL_fetch_arrays($res) {
  $ret=array();
  while ($row=SQL_fetch_array($res))
    $ret[]=$row;
  return $ret;
}

  
function SQL_fetch_row($res) {
  if (defined('USE_MYSQLI'))
    return mysqli_fetch_row($res);
  return mysql_fetch_row($res);
}  


function SQL_fetch_rows($res) {
  $ret=array();
  while ($row=SQL_fetch_row($res))
    $ret[]=$row;
  return $ret;
}
    
  
function SQL_data_seek($res,$row) {
  if (defined('USE_MYSQLI'))
    return mysqli_data_seek($res,$row);
  return mysql_data_seek($res,$row);
}
    
 
function SQL_num_fields($res) {
  if (defined('USE_MYSQLI'))
    return mysqli_num_fields($res);
  return mysql_num_fields($res);
}
        
 
function SQL_field_name($res,$field) {
  if (defined('USE_MYSQLI')) {
    $obj =  mysqli_fetch_field_direct($res, $field);
    return $obj->name;
  }
  return mysql_field_name($res,$field);
}

function SQL_insert_id() {
  global $mysql_link;

  $args=func_get_args();
  if (func_num_args()>0) {
    if (defined('USE_MYSQLI'))
      return mysqli_insert_id($args[0]);
    return mysql_insert_id($args[0]);
  }
  if (defined('USE_MYSQLI'))
    return mysqli_insert_id($mysql_link);
  return mysql_insert_id();
}

function SQL_escape($str) {
  global $mysql_link;

  if (is_array($str)) {
    $ret=array();
    reset($str);
    foreach($str as $var) {
      if (defined('USE_MYSQLI'))
        $ret[]=mysqli_real_escape_string($mysql_link, $var);
      else
        $ret[]=mysql_real_escape_string($var);
    }
    return $ret;
  }
  if (defined('USE_MYSQLI'))
    return mysqli_real_escape_string($mysql_link, $str);
  return mysql_real_escape_string($str);
}

function SQL_info_client() {
  global $mysql_link;

  if (defined('USE_MYSQLI'))
    return mysqli_get_client_info($mysql_link);
  return mysql_get_client_info();
}

function SQL_info_server() {
  global $mysql_link;

  if (defined('USE_MYSQLI'))
    return mysqli_get_server_info($mysql_link);
  return mysql_get_server_info();
}


function SQL_table_rows($table) {
  $ret=false;
  $res=SQL_query("SELECT count(*) FROM ".SQL_escape($table));
  if ($res) {
    if (($row=SQL_fetch_array($res)))
      $ret=$row[0];
    SQL_free_result($res);
  }
  return $ret;
}

?>