<?php

$doc="";
$doc_main="";
if (file_exists(PRG_PATH.'doc/index.html'))
  $doc_main=PRG_PATH.'doc/index.html';
elseif (file_exists(PRG_PATH.'doc/index.htm'))
  $doc_main=PRG_PATH.'doc/index.htm';
elseif (file_exists(PRG_PATH.'doc/doc.pdf'))
  $doc_main=PRG_PATH.'doc/doc.pdf';

if (defined('HELPMARK')) {
  $helpfile=preg_replace('/#.*/', '', HELPMARK);
  if (file_exists(PRG_PATH.'doc/'.$helpfile))
    $doc=PRG_PATH.'doc/'.HELPMARK;
  else
    $doc=$doc_main;
}



/* M E N U   D E F I N I T I O N S */



/* DATA MENU */
if (!isset($id_c)) $id_c="";
if (!isset($id_t)) $id_t="";
$menu_main["data"]=array(
  'caption'=>x("Data"),
  'url'=>PRG_PATH.'src/nf.php?subid=data',
  'info'=>x("In Data menu, there are main functions for traffic analysis.")
);

$menu_sub["data"][]=array(
  'caption'=>x("Overview"),
  'url'=>PRG_PATH."src/nf.php?nocheck=1",
  'icon'=>"overview.gif",
  'info'=>x("Display main screen window.")
);

$menu_sub["data"][]=array(
  'caption'=>x("Trends"),
  'url'=>PRG_PATH."src/data/trends.php?id_c=$id_c&id_t=$id_t",
  'icon'=>"trend.gif",
  'visible'=>CheckRights("search"),
  'info'=>x("Show trend statistics, graph and table output.")
);

$menu_sub["data"][]=array(
  'caption'=>x("Search"),
  'url'=>PRG_PATH."src/data/search.php?id_c=$id_c&id_t=$id_t",
  'icon'=>"search.gif",
  'visible'=>CheckRights("search"),
  'info'=>x("Detailed searching, output is formatted into table.")
);

$menu_sub["data"][]=array(
  'caption'=>x("Interfaces"),
  'url'=>PRG_PATH."src/data/iface.php?id_c=$id_c&id_t=$id_t",
  'icon'=>"iface.gif",
  'visible'=>CheckRights("search"),
  'info'=>x("Show input and output interface statistic, graph and table output.")
);

$menu_sub["data"][]=array(
  'caption'=>x("IP information"),
  'url'=>PRG_PATH.'src/data/info_ip.php',
  'icon'=>"infoip.gif",
  'info'=>x("Get information about IP address.")
);

$menu_sub["data"][]=array(
  'caption'=>x("AS information"),
  'url'=>PRG_PATH.'src/data/info_as.php',
  'icon'=>"infoas.gif",
  'info'=>x("Get information about autonomous system from local and whois database.")
);

$menu_sub["data"][]=array(
  'caption'=>x("Graphs"),
  'url'=>PRG_PATH.'src/data/graphs.php',
  'icon'=>"graph.gif",
  'info'=>x("Displaying previously generated graphs via Trends menu.")
);

$menu_sub["data"][]=array(
  'caption'=>x("Utilization map"),
  'url'=>PRG_PATH.'src/data/utilmap.php',
  'icon'=>"utilmap.gif",
  'visible'=>CheckRights("utilmap"),
  'info'=>x("Managing and displaying of the utilization maps.")
);




/* PROFILES MENU */
$menu_main["profiles"]=array(
  'caption'=>x("Profiles"),
  'url'=>PRG_PATH.'src/nf.php?subid=profiles',
  'info'=>x("The Profiles menu allows you to manage stored trends and search profiles.")
);

$menu_sub["profiles"][]=array(
  'caption'=>x("Trends"),
  'url'=>PRG_PATH.'src/profiles/trends.php',
  'icon'=>"trend.gif",
  'info'=>x("Manage stored trends profiles.")
);

$menu_sub["profiles"][]=array(
  'caption'=>x("Search"),
  'url'=>PRG_PATH.'src/profiles/search.php',
  'icon'=>"search.gif",
  'info'=>x("Manage stored search profiles.")

);

$menu_sub["profiles"][]=array(
  'caption'=>x("Interfaces"),
  'url'=>PRG_PATH.'src/profiles/iface.php',
  'icon'=>"iface.gif",
  'info'=>x("Manage stored interfaces profiles.")
);




/* EXPORTS MENU */
$menu_main["exports"]=array(
  'caption'=>x("Exports"),
  'url'=>PRG_PATH.'src/nf.php?subid=exports',
  'visible'=>CheckRights("export"),
  'info'=>x("In Exports menu, there are functions for exporting and importing data tables or query results.")
);

$menu_sub["exports"][]=array(
  'caption'=>x("Export list"),
  'url'=>PRG_PATH.'src/exports/export.php',
  'icon'=>"export.gif",
  'visible'=>CheckRights("export"),
  'info'=>x("Download exported tables or trends and search results."),
  'comment'=>x("In the export list you can find exported whole data tables or trends and search results.")
);

$menu_sub["exports"][]=array(
  'caption'=>x("Export status"),
  'url'=>PRG_PATH.'src/exports/exports.php',
  'icon'=>"exports.gif",
  'visible'=>CheckRights("export"),
  'info'=>x("See request queue and state of export process.")
);

$menu_sub["exports"][]=array(
  'caption'=>x("Import list"),
  'url'=>PRG_PATH.'src/exports/import.php',
  'icon'=>"import.gif",
  'visible'=>CheckRights("admin"),
  'info'=>x("Import files into the system."),
  'comment'=>x("Display previously exported files that can be imported into the system.")
);

$menu_sub["exports"][]=array(
  'caption'=>x("Import status"),
  'url'=>PRG_PATH.'src/exports/imports.php',
  'icon'=>"imports.gif",
  'visible'=>CheckRights("admin"),
  'info'=>x("See request queue and state of import process.")
);




/* ANOMALIES MENU */
$menu_main["anomaly"]=array(
  'caption'=>x("Anomalies"),
  'url'=>PRG_PATH.'src/anomaly/anomaly.php',
  'info'=>x("In Anomalies menu, there is list of detected network anomalies.")
);

$menu_sub["anomaly"][]=array(
  'caption'=>x("List of incidents"),
  'url'=>PRG_PATH.'src/anomaly/anomaly.php',
  'icon'=>"anomaly.gif",
  'info'=>x("List of detected network anomalies, alerts and incidents.")
);

$menu_sub["anomaly"][]=array(
  'caption'=>x("Search incident"),
  'url'=>PRG_PATH.'src/anomaly/search.php?type=incident',
  'icon'=>"anomalys.gif",
  'info'=>x("Search network incident.")
);

$menu_sub["anomaly"][]=array(
  'caption'=>x("Search alert"),
  'url'=>PRG_PATH.'src/anomaly/search.php?type=alert',
  'icon'=>"anomalys.gif",
  'info'=>x("Search network alert.")
);

$menu_sub["anomaly"][]=array(
  'caption'=>x("Search anomaly"),
  'url'=>PRG_PATH.'src/anomaly/search.php?type=anomaly',
  'icon'=>"anomalys.gif",
  'info'=>x("Search network anomaly.")
);




/* STATUS MENU */
$menu_main["status"]=array(
  'caption'=>x("Status"),
  'url'=>PRG_PATH.'src/nf.php?subid=status',
  'visible'=>CheckRights("status"),
  'info'=>x("In the Status menu you can get information about state of all system components.")
);

$menu_sub["status"][]=array(
  'caption'=>x("Engine"),
  'url'=>PRG_PATH.'src/status/engine.php',
  'icon'=>"engine.gif",
  'visible'=>CheckRights("status"),
  'info'=>x("Display state of installed components.")
);

$menu_sub["status"][]=array(
  'caption'=>x("Devices"),
  'url'=>PRG_PATH.'src/status/devices.php',
  'icon'=>"device.gif",
  'visible'=>CheckRights("status"),
  'info'=>x("Display state of devices, list of interfaces, link error numbers.")
);

$menu_sub["status"][]=array(
  'caption'=>x("Units"),
  'url'=>PRG_PATH.'src/status/units.php',
  'icon'=>"unit.gif",
  'visible'=>CheckRights("status"),
  'info'=>x("Display state of units, display units running processes.")
);

$menu_sub["status"][]=array(
  'caption'=>x("Collectors"),
  'url'=>PRG_PATH.'src/status/colls.php',
  'icon'=>"coll.gif",
  'visible'=>CheckRights("status"),
  'info'=>x("Display state of collectors, number of received or dropped flows etc.")
);

$menu_sub["status"][]=array(
  'caption'=>x("Last login"),
  'url'=>PRG_PATH.'src/status/lastlog.php',
  'icon'=>"lastlog.gif",
  'visible'=>CheckRights("admin"),
  'info'=>x("Show list of all software login.")
);

$menu_sub["status"][]=array(
  'caption'=>x("Tables"),
  'url'=>PRG_PATH.'src/status/tables.php?start=1',
  'icon'=>"table.gif",
  'visible'=>CheckRights("status"),
  'info'=>x("Show list of all flow tables, sizes, number of rows etc.")
);

$menu_sub["status"][]=array(
  'caption'=>x("Database"),
  'url'=>PRG_PATH.'src/status/database.php',
  'icon'=>"database.gif",
  'visible'=>CheckRights("status"),
  'info'=>x("Show list of running database processes, list of all database tables.")
);




/* OPTIONS MENU */
$menu_main["options"]=array(
  'caption'=>x("Options"),
  'url'=>PRG_PATH.'src/nf.php?subid=options',
  'info'=>x("Configuration options.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Global"),
  'url'=>PRG_PATH.'src/options/global.php',
  'icon'=>"global.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Configure authentication, SNMP community and other global settings."), 
  'comment'=>x("Configure global options, skin of the web interface, default SNMP community string, email setting and authentication.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Devices"),
  'url'=>PRG_PATH.'src/options/devices.php',
  'icon'=>"device.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Manage netflow data export devices (routers and switches).")
);

$menu_sub["options"][]=array(
  'caption'=>x("Units"),
  'url'=>PRG_PATH.'src/options/units.php',
  'icon'=>"unit.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Manage servers on which you run netflow collectors.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Collectors"),
  'url'=>PRG_PATH.'src/options/colls.php',
  'icon'=>"coll.gif",
  'visible'=>CheckRights("options,collector"),
  'info'=>x("Configure all collectors - listening ports, number of stored tables, tables format etc.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Anomalies"),
  'url'=>PRG_PATH.'src/options/anomaly.php',
  'icon'=>"anomaly.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Configure network anomalies detection.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Networks"),
  'url'=>PRG_PATH.'src/options/networks.php',
  'icon'=>"network.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Define your network or foreign IP networks.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Applications"),
  'url'=>PRG_PATH.'src/options/apps.php',
  'icon'=>"app.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Define own rules for heuristic application recognizer.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Forwarding"),
  'url'=>PRG_PATH.'src/options/forward.php',
  'icon'=>"fwd.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Define rules for forwarding netflow data exports to other destinations.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Filtering"),
  'url'=>PRG_PATH.'src/options/filter.php',
  'icon'=>"filter.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Define rules for filtering (allow/drop/modify) netflow data exports.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Image store"),
  'url'=>PRG_PATH.'src/options/imagestore.php',
  'icon'=>"imagestore.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Upload and manage images for using in the utilization maps or in the graphs.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Host list"),
  'url'=>PRG_PATH.'src/options/hosts.php',
  'icon'=>"listhost.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Manage host name database.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Port list"),
  'url'=>PRG_PATH.'src/options/ports.php',
  'icon'=>"listport.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Manage port name database.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Country list"),
  'url'=>PRG_PATH.'src/options/country.php',
  'icon'=>"listcc.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Manage database of countries.")
);

$menu_sub["options"][]=array(
  'caption'=>x("AS list"),
  'url'=>PRG_PATH.'src/options/as.php',
  'icon'=>"listas.gif",
  'visible'=>CheckRights("options"),
  'info'=>x("Manage autonomous systems database.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Groups"),
  'url'=>PRG_PATH.'src/options/groups.php',
  'icon'=>"group.gif",
  'visible'=>CheckRights("admin"),
  'info'=>x("Manage groups of users, their access rights and view restrictions.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Users"),
  'url'=>PRG_PATH.'src/options/users.php',
  'icon'=>"user.gif",
  'visible'=>CheckRights("admin"),
  'info'=>x("Manage users, sets passwords, graph resolutions, skins, etc.")
);

$menu_sub["options"][]=array(
  'caption'=>x("Account"),
  'url'=>PRG_PATH.'src/options/account.php',
  'icon'=>"account.gif",
  'info'=>x("Change account values of actual logged user.")
);




/* HELP MENU */
$menu_main["help"]=array(
  'caption'=>x("Help"),
  'url'=>PRG_PATH.'src/nf.php?subid=help',
  'info'=>x("Documentation, product version, PHP information, list of well-known ports and license management.")
);

$menu_sub["help"][]=array(
  'caption'=>x("Documentation"),
  'url'=>$doc_main,
  'icon'=>"doc.gif",
  'url_other'=>' TARGET="helpwin"',
  'visible'=>(isset($doc_main) && $doc_main!='')? true : false,
  'info'=>x("Display full product documentation.")
);

$menu_sub["help"][]=array(
  'caption'=>x("About"),
  'url'=>PRG_PATH.'src/help/about.php',
  'icon'=>"about.gif",
  'info'=>x("Get information about product version.")
);

$menu_sub["help"][]=array(
  'caption'=>x("PHP Info"),
  'url'=>PRG_PATH.'src/help/phpinfo.php',
  'icon'=>'php.gif',
  'visible'=>CheckRights("admin"),
  'info'=>x("Show PHP detail information.")
);

$menu_sub["help"][]=array(
  'caption'=>x("TCP/UDP ports"),
  'url'=>PRG_PATH.'src/help/ports.php',
  'icon'=>"port.gif",
  'info'=>x("Show list of some well-known TCP and UDP ports.")
);

$menu_sub["help"][]=array(
  'caption'=>x("Bug report"),
  'url'=>PRG_PATH.'src/help/bugreport.php',
  'icon'=>"bugreport.gif",
  'visible'=>defined('PRG_HOMEMAIL'),
  'info'=>x("Report bug to our support team.")
);

$menu_sub["help"][]=array(
  'caption'=>x("Debug file"),
  'url'=>PRG_PATH.'src/help/debug.php',
  'icon'=>"debug.gif",
  'visible'=>CheckRights("admin"),
  'info'=>x("Display debug information.")
);

$menu_sub["help"][]=array(
  'caption'=>x("License"),
  'url'=>PRG_PATH.'src/help/license.php',
  'icon'=>"license.gif",
  'visible'=>file_exists('/usr/share/netflow/license.txt'),
  'info'=>x("Display license agreement.")
);

$menu_sub["help"][]=array(
  'caption'=>x("License key"),
  'url'=>PRG_PATH.'src/help/lic_key.php',
  'icon'=>"lic_key.gif",
  'visible'=>CheckRights("admin"),
  'info'=>x("Manage license keys.")
);



/* CONTEXT HELP */
if (defined('HELPMARK') && $doc) {
  $menu_main["ctxhelp"]=array(
    'caption'=>ShowImage(x("Context help"),PRG_PATH.'images/ic_help.gif'),
    'url'=>$doc,
    'url_other'=>' target="helpwin"',
    'visible'=>(isset($doc) && $doc!='')? true : false
  );
}

?>