<?php
define('HELPMARK','#user_anomalies');
define('PRG_PATH','../../');

define('MAX_RESULTS',50);

require_once(PRG_PATH . 'core/main.php');
require_once(PRG_PATH . 'src/data/slib.php');
require_once('modules.php');
require_once('function.php');


getGlobalVar('command',$command);
getGlobalVar('cmd_search',$cmd_search);

getGlobalVar('type',$type);

getGlobalVar('st',$st);
getGlobalVar('et',$et);
getGlobalVar('ip',$ip);
getGlobalVar('cid',$cid);
getGlobalVar('na',$na);
getGlobalVar('xnas',$xnas);
getGlobalVar('resolver',$resolver);

getGlobalVar('order',$order);
getGlobalVar('offset',$offset);
getGlobalVar('id_inc',$id_inc);
getGlobalVar('id_al',$id_al);
getGlobalVar('id_an',$id_an);

if (!isset($command) || !$command) $command='';
if (!isset($type) || !$type) $type='';
if (!isset($st) || !$st) $st='';
if (!isset($et) || !$et) $et='';
if (!isset($ip) || !$ip) $ip='';
if (!isset($cid) || !$cid) $cid=0;
if (!isset($na) || !$na) $na='';
if (!isset($xnas) || !$xnas) $xnas='';
if (!isset($resolver)) $resolver=0; 

PageHead();
PageLogo();
MenuStart('anomaly');

switch ($type) {
  case "incident": PageTitle(x("Network anomalies - Search incident"),'i_anomalys.gif'); break;
  case "alert": PageTitle(x("Network anomalies - Search alert"),'i_anomalys.gif'); break;
  case "anomaly": PageTitle(x("Network anomalies - Search anomaly"),'i_anomalys.gif'); break;
  default: PageTitle(x("Network anomalies - Search"),'i_anomalys.gif');
	   MsgFatal(x("Unknown search type."));
}

anomaly_load_options();

$list_coll=list_table("x_coll","ORDER BY name");
$list_na=list_mod();

if (!isset($offset) || !is_numeric($offset) || $offset<0)
  $offset=0;

$drn=!$resolver;

$list_xnas=array();
while (list($key,$val)=each($list_na)) {
  $list_xnas[$key*256]=$val;
  if (isset($na_mod[$key]['nas']) && is_array($na_mod[$key]['nas'])) {
    reset($na_mod[$key]['nas']);
    while (list($key2,$val2)=each($na_mod[$key]['nas']))
      $list_xnas[$key*256+$key2]=$val." / ".$val2;
  }
}

if ($cmd_search)
  $command="search";

$res_count=0;
$results=array();


FormStart("search.php");


echo InputHidden("type",$type);
echo InputHidden("id_inc",$id_inc);
echo InputHidden("id_al",$id_al);
echo InputHidden("id_an",$id_an);
echo InputHidden("order",$order);
echo InputHidden("resolver",$resolver);
echo InputHidden("command","search");

  popup_script("450","500");
  WinTStart();
  TItem(x("IP address range:"));
  TItem(Input('ip',$ip,255).show_history("ip","ip"));
  TNext();
  TItem(x("Start time:"));
  TItem(Input('st',$st,255));
  TNext();
  TItem(x("End time:"));
  TItem(Input('et',$et,255));
  if ($type=='alert' || $type=='anomaly') {
    TNext();
    TItem(x("Collector:"));
    TItem(InputSelect("cid",select_list(array(x("Any collector"))+$list_coll,$cid)));
    TNext();
    TItem(x("Anomaly:"));
    TItem(InputSelect("xnas",select_list(array(x("Any anomaly"))+$list_xnas,$xnas)));
  }
  TNext();
  TItem(InputCheck('resolver',"1",i_chk($resolver)).x("resolve hostnames"),"align=\"left\" colspan=\"2\"");
  TNext();
  TItem("<br/>".InputSubmit("cmd_search",x("Search")),'colspan="2" align="center"');
  WinEnd();

  echo "<br/>\n";

  if ($command) {
    $sql_cond="WHERE 1";
    $sql_order="";
    $sql_q_cnt="";
    $sql_q_res="";

    $error="";
    $where="";

    switch ($type) {
      case 'incident':
	if ($ip!=='') {
	  parse_ip($where,"src",$ip,0);
	  $where="((srct=1 AND $where)OR(dstt=1 AND ".preg_replace('#src#', 'dst', $where)."))";
	  $sql_cond="WHERE $where";
	}
	if ($st!=='') {
	  $xst=strtotime($st);
	  if ($xst<0) $error="Invalid time $st.";
	  $sql_cond.=" AND st>='$xst'";
	}
	if ($et!=='') {
	  $xet=strtotime($et);
	  if ($xet<0)
	    $error="Invalid time $et.";
	  elseif ($xet == strtotime(strftime("%x",$xet)." 00:00:00"))
	    $xet=strtotime(strftime("%x",$xet)." 23:59:59");
	  $sql_cond.=" AND et<='$xet'";
	}
	$sql_order=get_order(array('st'=>'st','et'=>'et','src'=>'src','dst'=>'dst','sev'=>'severity','int'=>'internal','len'=>'len'),"severity DESC,internal,et DESC"); 
	$sql_q_cnt="SELECT count(*) FROM x_na_inc $sql_cond";
	$sql_q_res="SELECT *,(et-st)as len FROM x_na_inc $sql_cond $sql_order LIMIT $offset,".MAX_RESULTS;
	break;
      case 'alert':
	if ($ip!=='') {
	  parse_ip($where,"src",$ip,0);
	  $where="((srct=1 AND $where)OR(dstt=1 AND ".preg_replace('#src#','dst',$where)."))";
	  $sql_cond="WHERE $where";
	}
	if ($st!=='') {
	  $xst=strtotime($st);
	  if ($xst<0) $error="Invalid time $st.";
	  $sql_cond.=" AND st>='$xst'";
	}
	if ($et!=='') {
	  $xet=strtotime($et);
	  if ($xet<0)
	    $error="Invalid time $et.";
	  elseif ($xet == strtotime(strftime("%x",$xet)." 00:00:00"))
	    $xet=strtotime(strftime("%x",$xet)." 23:59:59");
	  $sql_cond.=" AND et<='$xet'";
	}
	if ($cid && isset($list_coll[$cid]))
    	  $sql_cond.=" AND cid='$cid'";
	if (floor($xnas/256))
    	  $sql_cond.=" AND na='".floor($xnas/256)."'";
	if ($xnas%256)
    	  $sql_cond.=" AND nas='".($xnas%256)."'";
	$sql_order=get_order(array('cid'=>'cid','prb'=>'prb','na'=>'na','st'=>'st','et'=>'et','src'=>'src','dst'=>'dst','sev'=>'severity','int'=>'internal','len'=>'len'),"severity DESC, et DESC");
	$sql_q_cnt="SELECT count(*) FROM x_na_al $sql_cond";
	$sql_q_res="SELECT *,(et-st)as len FROM x_na_al $sql_cond $sql_order LIMIT $offset,".MAX_RESULTS;
	break;
      case 'anomaly':
	if ($ip!=='') {
	  parse_ip($where,"src",$ip,0);
	  $where="((srct=1 AND $where)OR(dstt=1 AND ".preg_replace('#src#','dst',$where)."))";
	  $sql_cond="WHERE $where";
	}
	if ($st!=='') {
	  $xst=strtotime($st);
	  if ($xst<0) $error="Invalid time $st.";
	  $sql_cond.=" AND dt>='$xst'";
	}
	if ($et!=='') {
	  $xet=strtotime($et);
	  if ($xet<0)
	    $error="Invalid time $et.";
	  elseif ($xet == strtotime(strftime("%x",$xet)." 00:00:00"))
	    $xet=strtotime(strftime("%x",$xet)." 23:59:59");
	  $sql_cond.=" AND dt<='$xet'";
	}
	if ($cid && isset($list_coll[$cid]))
    	  $sql_cond.=" AND cid='$cid'";
	if (floor($xnas/256))
    	  $sql_cond.=" AND na='".floor($xnas/256)."'";
	if ($xnas%256)
    	  $sql_cond.=" AND nas='".($xnas%256)."'";
	$sql_order=get_order(array('cid'=>'cid','prb'=>'prb','na'=>'na','dt'=>'dt','src'=>'src','dst'=>'dst'),"dt DESC");
	$sql_q_cnt="SELECT count(*) FROM x_na_an $sql_cond";
	$sql_q_res="SELECT * FROM x_na_an $sql_cond $sql_order LIMIT $offset,".MAX_RESULTS;
	break;
    } /* switch */

    if ($error)
      MsgError($error);
    else {
      if ($ip) history_save("ip",$ip);

      $res=SQL_query($sql_q_cnt);
      if ($res) {
        if ($row=SQL_fetch_row($res))
          $res_count=$row[0];
        SQL_free_result($res);
      }
      else
        MsgError(x("Database query error."));
  
      if ($res_count>=1) {
        $res=SQL_query($sql_q_res);
        if ($res) {
          while ($row=SQL_fetch_array($res))
            $results[]=$row;
          SQL_free_result($res);
        }
        else
          MsgError(x("Database query error."));
      }

      /* FORMAT THE OUTPUT */

      if ($res_count) {
        reset($results);
        ShowNavigate("search.php",count($results),$offset,MAX_RESULTS,$res_count);
        switch ($type) {
          case 'incident':
	    WinTStart();
	    THItem(ShowLink(x("Start time"),get_orderlink("search.php","st")).
	      "<br/>".ShowLink(x("End time"),get_orderlink("search.php","et")).
	      "<br/>".ShowLink(x("Length"),get_orderlink("search.php","len")));
	    THItem(ShowLink(x("Source"),get_orderlink("search.php","src")));
	    THItem(ShowLink(x("Destination"),get_orderlink("search.php","dst")));
	    THItem(ShowLink(x("Severity"),get_orderlink("search.php","sev")));
	    THItem(ShowLink(x("Internal"),get_orderlink("search.php","int")));
	    THItem(ShowLink(x("State"),get_orderlink("search.php","state")));
 	    THItem(x("Commands"));
	    while (list($key,$row)=each($results)) {
              TAnomaly($row['severity'],$row['internal']);
              TItem(strftime("%Y/%m/%d %H:%M",$row['st']).
    	        "<br/>".strftime("%Y/%m/%d %H:%M",$row['et']).
	        "<br/>".get_length($row['len']));
              TItem(format_srcdst($row['srct'],$row['src'],$row));
              TItem(format_srcdst($row['dstt'],$row['dst'],$row));
              TItem($list_sev[$row['severity']]);
              TItem($list_int[$row['internal']]);
              TItem($list_state[$row['state']]);
              TItem(ShowLink(x("View detail"),"anomaly.php?command=incident&state=any&time=8&sev=1&int=0&id_inc=".$row['id']).
    	        get_incident_detail($row['id']));
	    }
	    WinEnd();    
	    break;
          case 'alert':
	    WinTStart();
	    THItem(ShowLink(x("Start time"),get_orderlink("search.php","st")).
	      "<br/>".ShowLink(x("End time"),get_orderlink("search.php","et")).
	      "<br/>".ShowLink(x("Length"),get_orderlink("search.php","len")));
	    THItem(ShowLink(x("Collector"),get_orderlink("search.php","cid")));
	    THItem(ShowLink(x("Anomaly"),get_orderlink("search.php","na")));
	    THItem(ShowLink(x("Source"),get_orderlink("search.php","src")));
	    THItem(ShowLink(x("Destination"),get_orderlink("search.php","dst")));
            THItem(ShowLink(x("Probability"),get_orderlink("search.php","prb")));
	    THItem(ShowLink(x("Severity"),get_orderlink("search.php","sev")));
	    THItem(ShowLink(x("Internal"),get_orderlink("search.php","int")));
 	    THItem(x("Commands"));
	    while (list($key,$row)=each($results)) {
              TAnomaly($row['severity'],$row['internal']);
              TItem(strftime("%Y/%m/%d %H:%M",$row['st']).
    	        "<br/>".strftime("%Y/%m/%d %H:%M",$row['et']).
	        "<br/>".get_length($row['len']));
	      TItem($list_coll[$row['cid']]);
    	      TItem(format_na($row['na'],$row['nas']));
              TItem(format_srcdst($row['srct'],$row['src'],$row));
              TItem(format_srcdst($row['dstt'],$row['dst'],$row));
	      TItem(round($row['prb'],4));
              TItem($list_sev[$row['severity']]);
              TItem($list_int[$row['internal']]);
              TItem(ShowLink(x("View detail"),"anomaly.php?command=alert&state=any&time=8&sev=1&int=0&id_inc=".$row['id_inc']."&id_al=".$row['id']).
    	        get_alert_detail($row['id']));
	    }
	    WinEnd();
	    break;
          case 'anomaly':
	    WinTStart();
	    THItem(ShowLink(x("Time"),get_orderlink("search.php","dt")));
	    THItem(ShowLink(x("Collector"),get_orderlink("search.php","cid")));
	    THItem(ShowLink(x("Anomaly"),get_orderlink("search.php","na")));
	    THItem(ShowLink(x("Source"),get_orderlink("search.php","src")));
	    THItem(ShowLink(x("Destination"),get_orderlink("search.php","dst")));
            THItem(ShowLink(x("Probability"),get_orderlink("search.php","prb")));
 	    THItem(x("Commands"));
	    while (list($key,$row)=each($results)) {
	      TLine();
	      TItem(strftime("%Y/%m/%d %H:%M",$row['dt']));
	      TItem($list_coll[$row['cid']]);
    	      TItem(format_na($row['na'],$row['nas']));
              TItem(format_srcdst($row['srct'],$row['src'],$row));
              TItem(format_srcdst($row['dstt'],$row['dst'],$row));
	      TItem(round($row['prb'],4));
              TItem(ShowLink(x("View detail"),"anomaly.php?command=anomaly&state=any&time=8&sev=1&int=0&id_inc=".$row['id_inc']."&id_al=".$row['id_al']."&id_an=".$row['id']));
	    }
	    WinEnd();
	    break;
        }
        if (count($results)>25)
          ShowNavigate("search.php",count($results),$offset,MAX_RESULTS,$res_count);
      }
      else
        MsgInfo(x("No rows found...<br/><ol><li>Better adjust search criteria.</li><li>Return to this page shortly.</li><li>Enable anomalies detection</li></ol>"));
    } /* if ! err */
  } /* search */




FormEnd();

MenuEnd();
PageTail();



/* F U N C T I O N S */

?>