<?php
define('HELPMARK','data_ipinfo.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('check',$check);
getGlobalVar('host',$host);
getGlobalVar('dns',$dns);
getGlobalVar('maxhops',$maxhops);
getGlobalVar('useudp',$useudp);
getGlobalVar('showttl',$showttl);
getGlobalVar('queries',$queries);
getGlobalVar('ws',$ws);
getGlobalVar('port',$port);


PageHead();
PageLogo();
MenuStart('data','MySubMenu');
PageTitle(x("IP address information"),'i_infoip.gif');


if ($command=="ping" || $command=="trace" || $command=="whois")
  RequireRights("shellcmd");

check_command('ping','trace','whois','http');
demo_cmd("ping");
demo_cmd("trace");
demo_cmd("whois");


$ws_a[""]=x("Auto");
$ws_a["arin"]=x("ARIN");
$ws_a["ripe"]=x("RIPE");
$ws_a["apnic"]=x("APNIC");

if (is_numeric($host))
  $host=num2ip($host);

if ($check&&$host) {
  if (is_ip($host)) {
    $host_ip=$host;
    $host_name=gethostbyaddr_cache($host);
  }
  else {
    $host_ip=gethostbyname($host);
    $host_name=$host;
    if ($host_ip==$host)
      $host_ip="";
  }

  if ($host_ip == "")
    MsgError(x("Can't resolve hostname or get IP address..."));
}
else
  $check="";




FormStart();
popup_script("450","500",'','no');

echo InputHidden("command",$command);

if ($command=="") {
  WinStart(x("Basic IP address information"));
  TItem(x("Hostname/IP:"));
  TItem(Input("host",$host,255).show_history("ip_host","host"));
}

if ($command=="ping") {
  WinStart(x("Ping IP address"));
  TItem(x("Hostname/IP:"));
  TItem(Input("host",$host,255));
}

if ($command=="trace") {  
  if (($maxhops<=0)||($numhops>64)) $maxhops="";
  if (($queries<=0)||($queries>10)) $queries="";
  if ($maxhops=="") $maxhops="16";
  
  WinStart(x("Traceroute to IP address"));
  TItem(x("Hostname/IP:"));
  TItem(Input("host",$host,255));
  TNext();  
  TItem(x("Maximum hops:"));
  TItem(Input("maxhops",$maxhops,"3"));    
  TNext();
  TItem("Retry queries:");
  TItem(Input("queries",$queries,"1"));
  TNext();  
  TItem(InputCheck("dns","1",i_chk($dns)).x("domain name resolution"),'COLSPAN="2"');    
  TNext();  
  TItem(InputCheck("useudp","1",i_chk($useudp)).x("use UDP instead ICMP"),'COLSPAN="2"');    
  TNext();  
  TItem(InputCheck("showttl","1",i_chk($showttl)).x("show TTL"),'COLSPAN="2"');    
}

if ($command=="whois") {  
  WinStart(x("Whois query"));
  TItem(x("Hostname/IP:"));
  TItem(Input("host",$host,255));
  TNext();  
  TItem(x("Whois server:"));
  TItem(InputSelect("ws",select_list($ws_a,$ws)));
}

if ($command=="http") {  
  if (($port<1)||($port>65535)) $port="";
  if ($port=="") $port="80";
  
  WinStart(x("HTTP HEAD request"));
  TItem(x("Hostname/IP:"));
  TItem(Input("host",$host,255));
  TNext();  
  TItem(x("Port:"));
  TItem(Input("port",$port,"5"));
}

TNext();
TItem("<BR>".InputSubmit("check",x("Get information")),'COLSPAN="2" ALIGN="center"');
WinEnd();
FormEnd();

echo "<BR><BR>\n";

if ($check && $host_ip && $host) {
  history_save("ip_host",$host);
  history_save("ip",$host);

  if ($command=="") {
    $hostl=gethostbynamel($host_name);
    if (is_array($hostl) && count($hostl)>1) {
      foreach($hostl as $host_ip_more)
        show_host_info($host_name,$host_ip_more);
    }
    else
      show_host_info($host_name,$host_ip);
  }
  
  if ($command=="ping") {
    $opt="";      
    $cmdline = EscapeShellCmd($opt." ".$host);    
    if (defined('PRG_EXEC_PING')) {
      exec(PRG_EXEC_PING." $cmdline",$output);
      echo "<PRE>\n";
      foreach ($output as $line)
        echo "$line\n";
      echo "</PRE>\n";
    }
    else
      MsgError(x("EXEC_PING isn't defined in config file..."));
  }

  if ($command=="trace") {
    $opt="";
    if (!$dns)
      $opt.=" -n";
    if (!$useudp)
      $opt.=" -I";
    if ($showttl)
      $opt.=" -l";
    if ($maxhops)
      $opt.=" -m ".$maxhops;
    if ($queries)
      $opt.=" -q ".$queries;
    $cmdline = EscapeShellCmd($opt." ".$host);    
    if (defined('PRG_EXEC_PING')) {    
      exec(PRG_EXEC_TRACE." $cmdline",$output);
      echo "<PRE>\n";
      foreach ($output as $line)
        echo "$line\n";
      echo "</PRE>\n";
    }
    else
      MsgError(x("EXEC_TRACE isn't defined in config file..."));
  }

  if ($command=="whois") {
    $whoissrv="";
    if ($ws=="arin")
      $whoissrv="-h whois.arin.net";
    if ($ws=="ripe")
      $whoissrv="-h whois.ripe.net";
    if ($ws=="apnic")
      $whoissrv="-h whois.apnic.net";

    $cmdline = EscapeShellCmd($host_ip);
    if (defined('PRG_EXEC_WHOIS')) {    
      exec(PRG_EXEC_WHOIS." $whoissrv $cmdline",$output);
      echo "<PRE>\n";
      foreach ($output as $line)
        echo formatlinkstring($line)."\n";
      echo "</PRE>\n";
    }
    else
      MsgError(x("EXEC_WHOIS isn't defined in config file..."));
  }

  if ($command=="http") {
    $fp = @fsockopen($host,$port,$errno,$errstr,5);
    if($fp) {
      fwrite($fp,"HEAD / HTTP/1.0\r\nHost: $host\r\nUser-Agent: Flow Monitor\r\nConnection: Close\r\n\r\n");
      echo "<PRE>\n";
      while (!feof($fp))
	echo fgets($fp,128);
      echo "</PRE>\n";    
      fclose($fp);
    }
    else
      MsgError(x("Died while attempting connection.")."<BR>$errstr");
  }
}

MenuEnd();
PageTail();






/* F U N C T I O N S */  

function show_host_info($host_name,$host_ip) {
    $ipnum=ip2num($host_ip);

    $c_cc="";
    $c_country="";
    $res=SQL_query("SELECT ipn_s,ipn_e,code FROM x_ip_cc_p WHERE ipn_s<='".SQL_escape($ipnum)."' AND ipn_e>='".SQL_escape($ipnum)."' LIMIT 1");
    if ($res) {
      $row=SQL_fetch_array($res);
      $c_ip_s=num2ip($row[0]);
      $c_ip_e=num2ip($row[1]);
      $c_cc=$row[2];
      SQL_free_result($res);
    }
    if (!$c_cc) {
      $res=SQL_query("SELECT ipn_s,ipn_e,code FROM x_ip_cc WHERE ipn_s<='".SQL_escape($ipnum)."' AND ipn_e>='".SQL_escape($ipnum)."' LIMIT 1");
      if ($res) {
        $row=SQL_fetch_array($res);
        $c_ip_s=num2ip($row[0]);
        $c_ip_e=num2ip($row[1]);
        $c_cc=$row[2];
        SQL_free_result($res);
      }
    }
    if ($c_cc) {
      $res=SQL_query("SELECT country FROM x_cc_p WHERE code='$c_cc' LIMIT 1");
      if ($res) {
        $row=SQL_fetch_array($res);
        $c_country=$row[0];
        SQL_free_result($res);
      }
      if (!$c_country) {
        $res=SQL_query("SELECT country FROM x_cc WHERE code='$c_cc' LIMIT 1");
        if ($res) {
          $row=SQL_fetch_array($res);
          $c_country=$row[0];
          SQL_free_result($res);
        }
      }
    }


    $as_asn="";
    $as_name="";
    $res=SQL_query("SELECT asn FROM x_ip_as_p WHERE ipn_s<='".SQL_escape($ipnum)."' AND ipn_e>='".SQL_escape($ipnum)."' LIMIT 1");
    if ($res) {
      $row=SQL_fetch_array($res);
      $as_asn=$row[0];
      SQL_free_result($res);
    }
    if (!$as_asn) {
      $res=SQL_query("SELECT asn FROM x_ip_as WHERE ipn_s<='".SQL_escape($ipnum)."' AND ipn_e>='".SQL_escape($ipnum)."' LIMIT 1");
      if ($res) {
        $row=SQL_fetch_array($res);
        $as_asn=$row[0];
        SQL_free_result($res);
      }
    }
    if ($as_asn) {
      $res=SQL_query("SELECT name,descr FROM x_as_p WHERE asn='$as_asn' LIMIT 1");
      if ($res) {
        $row=SQL_fetch_array($res);
        $as_name=ucwords(trim($row[0]));
        $as_desc=ucwords(trim($row[1]));
        SQL_free_result($res);
      }
      if (!$as_name) {
        $res=SQL_query("SELECT name,descr FROM x_as WHERE asn='$as_asn' LIMIT 1");
        if ($res) {
          $row=SQL_fetch_array($res);
          $as_name=ucwords(trim($row[0]));
          $as_desc=ucwords(trim($row[1]));
          SQL_free_result($res);
        }
      }
    }

    $reverse=gethostbyaddr_cache($host_ip);
    $domain="";
    if ($host_name!=$host_ip) {
      $domain_a=explode('.',$host_name);
      if (is_array($domain_a) && count($domain_a)>=3) {
        $domain_a[0]="www";
        $domain=implode('.',$domain_a);
	if ($domain!=$host_name)
          $domain=ShowLink($domain,"info_ip.php?host=$domain&check=1",'','TARGET="_blank"');
	else
          $domain="";
      }
    }
    WinTStart();
    TItem("Hostname:");
    TItem(($host_name!=$host_ip)?ShowLink($host_name,"http://".$host_name,'','TARGET="info"'):x("missing reverse DNS record"));
    if ($reverse!=$host_name && $host_name!=$host_ip) {
      TNext();
      TItem(x("Reverse hostname:"));
      TItem(ShowLink($reverse,"http://".$reverse,'','TARGET="info"'));
    }
    TNext();
    TItem("IP address:");
    TItem($host_ip." (".ip2num($host_ip).")");
    TNext();
    TItem("Range:");
    TItem(get_inet_range($host_ip));
    if ($domain) {
      TNext();
      TItem(x("Domain URL:"));
      TItem($domain);
    }
    if ($c_cc) {
      TNext();
      TItem(x("Country IP range:"));
      TItem($c_ip_s." - ".$c_ip_e);
      TNext();
      TItem(x("Country code:"));
      if (file_exists(PRG_PATH.'images/flag/'.strtolower($c_cc).'.gif')) {
        TItem($c_cc.'&nbsp;&nbsp;'.ShowImage($c_cc,PRG_PATH.'images/flag/'.strtolower($c_cc).'.gif'));
      }
      else
        TItem($c_cc);
      if ($c_country) {
        TNext();
        TItem(x("Country:"));
        TItem($c_country);
      }
    }
    if ($as_asn) {
      TNext();
      TItem(x("Autonomous system:"));
      TItem(ShowLink($as_asn,"info_as.php?as=$as_asn&command=1"));
      if ($as_name || $as_desc) {
        TNext();
        TItem(x("AS description:"));
        if ($as_name && $as_desc)
          TItem("$as_name - $as_desc");
        elseif ($as_name)
          TItem($as_name);
        else
          TItem($as_desc);
      }
    }
    WinEnd();
    echo "<BR><BR>\n";
}


function get_inet_range($ip) {
  $lip = ip2num($ip);
    settype($lip,"double");
    
  if (($lip >= 167772160) && ($lip < 184549376))
    $adv=x("(private 10.0.0.0/8)");
  if (($lip >= 2886729728) && ($lip < 2887843840))
    $adv=x("(private 172.16.0.0/12)");
  if (($lip >= 3232235520) && ($lip < 3232301056))
    $adv=x("(private 192.168.0.0/16)");
  if (($lip >= 2130706432) && ($lip < 2147483648))
    $adv=x("(loopback)");
    
  /* 0xxx xxxx ... */
  if ($lip < 2147483648) {
    $lo = num2ip($lip & 0xFF000000);
    $hi = num2ip($lip | 0x00FFFFFF);
    $class=x("Class A");
  }

  /* 10xx xxxx ... */
  elseif ($lip < 3221225472) {
    $lo = num2ip($lip & 0xFFFF0000);
    $hi = num2ip($lip | 0x0000FFFF);
    $class=x("Class B");
  }

  /* 110x xxxx ... */
  elseif ($lip < 3758096384) {        
     $lo = num2ip($lip & 0xFFFFFF00);
     $hi = num2ip($lip | 0x000000FF);
     $class=x("Class C");
  }

  /* 1110 xxxx ... */
  elseif ($lip < 4026531840) {
    $lo = "";
    $hi = "";
    $class=x("Class D");
  }
  
  else {
    $lo="";
    $hi="";
    $class=x("Class E");
  }
  return $class." ".$lo." - ".$hi." ".$adv;
}



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("Basic"),'url'=>"info_ip.php?".args(array(check=>"",command=>"")));
  if (CheckRights("shellcmd")) {
    $mysubmenu[]=array('caption'=>x("Ping"),'url'=>"info_ip.php?".args(array(check=>"",command=>"ping")));
    $mysubmenu[]=array('caption'=>x("Traceroute"),'url'=>"info_ip.php?".args(array(check=>"",command=>"trace")));
    $mysubmenu[]=array('caption'=>x("Whois"),'url'=>"info_ip.php?".args(array(check=>"",command=>"whois")));
  }
  $mysubmenu[]=array('caption'=>x("HTTP request"),'url'=>"info_ip.php?".args(array(check=>"",command=>"http")));
  MenuSub(x("IP address info"),$mysubmenu);
}

?>