<?php

define('PRG_PATH','../');

require_once(PRG_PATH . 'core/jg/jpgraph.php');
require_once(PRG_PATH . 'core/jg/jpgraph_line.php');
require_once(PRG_PATH . 'core/jg/jpgraph_canvas.php');

require_once(PRG_PATH . 'core/constant.php');
require_once(PRG_PATH . 'core/config.php');
require_once(PRG_PATH . 'core/msgdlg.php');
require_once(PRG_PATH . 'core/global.php');
require_once(PRG_PATH . 'core/prgsession.php');

require_once(PRG_PATH . 'core/gettext.php');
require_once(PRG_PATH . 'core/option.php');
require_once(PRG_PATH . 'core/html.php');
require_once(PRG_PATH . 'core/database.php');
require_once(PRG_PATH . 'core/func.php');
require_once(PRG_PATH . 'core/menu.php');
require_once(PRG_PATH . 'core/specific.php');


getGlobalVar('id',$id);
getGlobalVar('t',$t);
getGlobalVar('mode',$mode);

/*
if mode=='full' then display 6 hours history in the image 320x200
*/


if (!headers_sent()) {
  header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
  header ("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
  header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
  header ("Pragma: no-cache");                          // HTTP/1.0
}

SQL_opendefault();
$em_gh=generate_graph($id,$t,_IMG_HANDLER,$mode);
SQL_close(); 
if ($em_gh) {
  if (!headers_sent())
    header("Content-type: image/png");
  imagepng($em_gh);
}




function generate_graph($id,$type,$handler,$mode) { 
  /* constants */
  $theight=20;  /* height of text side */
  $num_utl=5;	/* number of minute for counting utilization */
  $tick_int=60; /* every 60 min */

  /* default values */
  $minutes=90;	/* number of minute history */
  $size_x=93;	/* size of x graph (add 3 for shading)*/
  $size_y=65;
  $util_bits=0;	/* show values in the bytes bits instead of bits */
  $util_persec=0; /* show values per minute instead of per sec */
  $util_clean=0;
  $graph_aa=0;
  $margin_left=0; /* left graph margin */

  $res=SQL_query("SELECT name,value from x_global");
  if ($res) {
    while ($row=SQL_fetch_array($res)) {
      switch ($row[0]) {
        case "util_hist": if ($row[1]>=30 && $row[1]<=360) $minutes=$row[1]; break;
        case "util_persec": if ($row[1]) $util_persec=1; break;
        case "util_bits": if ($row[1]) $util_bits=1; break;
        case "util_clean": if ($row[1]) $util_clean=1; break;
        case "graph_aa": if ($row[1]) $graph_aa=1; break;
        case "util_sizex": if ($row[1]>=93 && $row[1]<=150) $size_x=$row[1]; break;
        case "util_sizey": if ($row[1]>=65 && $row[1]<=150) $size_y=$row[1]; break;
      }
    }
    SQL_free_result($res);
  }

  if ($mode=='full') {
    $size_x=320;
    $size_y=200;
    $util_clean=0;
    $minutes=360;
    $margin_left=34;
  }

  if ($type!='p') $type='b';

  $dte=floor(time()/60)*60;
  $dts=$dte-(60*$minutes)+60;
  $base=floor($dte/3600)*3600;
  $w=SQL_escape(array($id,$dts,$dte,$type));

  $glb_data=array();
  $cur_data=array();
  $cur_graph=array();

  $glb_st=$dts;
  $glb_et=$dte;
  $glb_max=0;

  $res=SQL_query("DELETE FROM x_util WHERE dt<".(time()-(86400*90))." OR dt>".(time()+7200));
  if (!$res)
    SQL_query("REPAIR TABLE x_util"); /* fix corrupted table */ 

  $res=SQL_query("SELECT dt,sum(v)as sv FROM x_util WHERE cid='$w[0]' AND t='$w[3]' GROUP BY dt");
  if ($res) {
    while (($row=SQL_fetch_array($res))) {
      if ($util_persec)
	$row[1]=$row[1]/60;
      if ($util_bits && $type=='b')
	$row[1]=$row[1]*8;
      if ($glb_st>$row[0])
        $glb_st=$row[0];
      if ($glb_et<$row[0])
	$glb_et=$row[0];
      if ($row[1]>$glb_max)
	$glb_max=$row[1];
      $glb_data[$row[0]]=$row[1];
    }
    SQL_free_result($res);
  }

  for ($i=$glb_st;$i<=$glb_et;$i+=60) {
    if ($i>=$dts && $i<=$dte) {
      if (!isset($glb_data[$i]))
        $glb_data[$i]="0";
      $cur_data[$i]=$glb_data[$i];
    }
  }
  ksort($glb_data);
  reset($glb_data);

 
/* count current window values */
  $cur_avg=0;
  $cur_avg_num=0;
  $cur_max=0;

  for ($i=$dts;$i<=$dte;$i+=60) {
    if (!isset($cur_data[$i]))
      $cur_data[$i]="0";
    if ($cur_max<$cur_data[$i])
      $cur_max=$cur_data[$i];
    if ($cur_data[$i]>0) {
      if ($cur_avg_num)
        $cur_avg=($cur_avg*($cur_avg_num/($cur_avg_num+1)))+($cur_data[$i]/($cur_avg_num+1));
      else
        $cur_avg=$cur_data[$i];
      $cur_avg_num++;
    }
  }
  ksort($cur_data);
  reset($cur_data);

/* count num minutes utilization */
  $i=0;
  $cur_utl=0;
  $num=count($cur_data);
  foreach ($cur_data as $t1) {
    $cur_graph[]=$t1;
    if ($i>=$num-$num_utl-1 && $i<$num-1)
      $cur_utl+=round($t1/$num_utl);
    $i++;
  }

  if ($cur_utl<$cur_avg)
    $cur_utl=(2/5)*$cur_avg + (3/5)*$cur_utl;

/* SHOW GRAPH */
  $graph = new Graph($size_x,$size_y,"");
  
  if ($util_clean)
    $graph->img->SetMargin($margin_left,3,0,3);
  else
    $graph->img->SetMargin($margin_left,3,0,$theight+1);
  
 

  if ($graph_aa)
    $graph->img->SetAntiAliasing(); 


  $graph->SetScale("textlin");
  $graph->SetShadow(true,1);
  $graph->SetMarginColor('#FFFFD8');

  if ($mode=='full') {
    $graph->yaxis->SetLabelFormatCallback('number2human');
    $graph->yaxis->SetFont(FF_FONT0,FS_BOLD);
    $graph->yaxis->HideZeroLabel();
    $graph->yaxis->SetLabelMargin(2);
    $label="";
    if ($type=='p' && $util_persec)
      $label=x("Packets per second");
    elseif ($type=='p')
      $label=x("Packets per minute");
    elseif ($util_persec && $util_bits)
      $label=x("Bits per second");
    elseif ($util_persec)
      $label=x("Bytes per second");
    elseif ($util_bits)
      $label=x("Bits per minute");
    else
      $label=x("Bytes per minute");
    $graph->title->Set($label);
  }

  $prc=0;
  if ($glb_max) {
    $prc=round(($cur_utl/$glb_max)*100);
    if ($prc>100) $prc=100;
    if ($prc<0) $prc=0;

    if (!$util_bits || $type=='p')
      $type=strtoupper($type);

    if ($cur_avg>=1000)
      $left=strtoupper(number2human($cur_avg,0,1,1)).$type."\n";
    else
      $left=strtoupper(number2human($cur_avg,0,1,1)).' '.$type."\n";

    if ($cur_max>=1000)
      $left.=strtoupper(number2human($cur_max,0,1,1)).$type;
    else
      $left.=strtoupper(number2human($cur_max,0,1,1)).' '.$type;

    $right="$prc%\n";
    if ($glb_max>=1000)
      $right.=strtoupper(number2human($glb_max,0,1,1)).$type;
    else
      $right.=strtoupper(number2human($glb_max,0,1,1)).' '.$type;

    if (!$util_clean) {
      $txtl=new Text($left); 
      $txtl->Pos($size_x/2,$size_y-4,"right","bottom"); 
      $txtl->ParagraphAlign('right');
      $txtl->SetFont(FF_FONT0,FS_BOLD,7); 
      $graph->AddText($txtl);

      $txtr=new Text($right); 
      $txtr->Pos($size_x-2,$size_y-4,"right","bottom"); 
      $txtr->ParagraphAlign('right');
      $txtr->SetFont(FF_FONT0,FS_BOLD,7); 
      $graph->AddText($txtr);
    }
  }
  elseif (!$util_clean) {
    $txt=new Text(x("NO DATA FLOWS")); 
    $txt->Pos($size_x/2,$size_y-($theight/2)-1,"center","center"); 
    $txt->SetFont(FF_FONT1,FS_NORMAL,6); 
    $graph->AddText($txt);
  }


  /* get graph color */
  if ($prc < 50)
    $dc1="#008000";	/* green */
  elseif ($prc < 70)
    $dc1="#A0A000"; /* yellow */
  elseif ($prc < 80)
    $dc1="#FF8000"; /* orange */
  elseif ($prc < 90)
    $dc1="#FF4000"; /* redorange */
  else
    $dc1="#FF0000"; /* red */

  $graph->yaxis->scale->SetAutoMin(0);


  $start_tick=($minutes-(($dte-$base)/60))%$tick_int;
  $graph->xaxis->HideLabels();
  $graph->xaxis->HideLine();
  $graph->xaxis->SetTextTickInterval($tick_int,$start_tick); 


  $lp1 = new LinePlot($cur_graph);
  $lp1->SetFillColor(get_fill_color($dc1,1.7));
  $lp1->SetColor($dc1);
  $graph->Add($lp1);

  $hdl=$graph->Stroke($handler);
  return $hdl;
}


/* F U N C T I O N S */


function get_fill_color($aColor,$ratio) {
  $r=round((hexdec(substr($aColor,1,2))+255)/$ratio);
  if ($r>255) $r=255;
  $g=round((hexdec(substr($aColor,3,2))+255)/$ratio);
  if ($g>255) $g=255;
  $b=round((hexdec(substr($aColor,5,2))+255)/$ratio);
  if ($b>255) $b=255;
  return sprintf("#%02x%02x%02x", $r , $g , $b );
}

?>