<?php
define('HELPMARK','config_anomalies_glb.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');
require_once(PRG_PATH . 'src/data/slib.php'); /* due to parse_ip */
require_once(PRG_PATH . 'src/anomaly/modules.php');


getGlobalVar('command',$command);
getGlobalVar('btn_save',$btn_save);


getGlobalVar('report_body_head',$report_body_head);
getGlobalVar('report_body_tail',$report_body_tail);
getGlobalVar('report_subject',$report_subject);
getGlobalVar('report_i_email',$report_i_email);
getGlobalVar('report_e_email',$report_e_email);
getGlobalVar('clean_new',$clean_new);
getGlobalVar('clean_other',$clean_other);
getGlobalVar('color_i_cri',$color_i_cri);
getGlobalVar('color_i_urg',$color_i_urg);
getGlobalVar('color_i_imp',$color_i_imp);
getGlobalVar('color_i_war',$color_i_war);
getGlobalVar('color_i_inf',$color_i_inf);
getGlobalVar('color_e_cri',$color_e_cri);
getGlobalVar('color_e_urg',$color_e_urg);
getGlobalVar('color_e_imp',$color_e_imp);
getGlobalVar('color_e_war',$color_e_war);
getGlobalVar('color_e_inf',$color_e_inf);

require_once(PRG_PATH . 'src/anomaly/function.php');

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Network anomalies - Global"),'i_anomaly.gif');
RequireRights("options");

check_command('update');

demo_cmd("update");


$list_coll=list_table("x_coll","ORDER BY name");

if (!is_array($list_coll)|| !count($list_coll))
  MsgFatal(x("No available collector. Go to menu Options-&gt;Collectors first."));

if (!is_array($na_mod) || !count($na_mod))
  MsgFatal(x("No available network anomaly module."));


if ($command=="update") {
  $error="";
  if (!is_numeric($clean_new) || $clean_new<1 || $clean_new>91)
    $error=x("Clean new anomalies value can be in the range [1-91].");
  else if (!is_numeric($clean_other) || $clean_other<1 || $clean_other>200)
    $error=x("Clean other anomalies value can be in the range [1-200].");
  else if (chkclr($color_i_cri)||chkclr($color_i_urg)||chkclr($color_i_imp)||chkclr($color_i_war)||chkclr($color_i_inf))
    $error=x("Wrong color format for internal networks. Color has to be in RGB format [XXXXXX] where X is 0-F.");
  else if (chkclr($color_e_cri)||chkclr($color_e_urg)||chkclr($color_e_imp)||chkclr($color_e_war)||chkclr($color_e_inf))
    $error=x("Wrong color format for external networks. Color has to be in RGB format [XXXXXX] where X is 0-F.");
  if (!$error &&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='report_body_head',v1='".SQL_escape($report_body_head)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='report_body_tail',v1='".SQL_escape($report_body_tail)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='report_subject',v1='".SQL_escape($report_subject)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='report_i_email',v1='".SQL_escape($report_i_email)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='report_e_email',v1='".SQL_escape($report_e_email)."'"))&&

    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='clean_new',v1='".SQL_escape($clean_new)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='clean_other',v1='".SQL_escape($clean_other)."'"))&&

    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_i_cri',v1='".SQL_escape($color_i_cri)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_i_urg',v1='".SQL_escape($color_i_urg)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_i_imp',v1='".SQL_escape($color_i_imp)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_i_war',v1='".SQL_escape($color_i_war)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_i_inf',v1='".SQL_escape($color_i_inf)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_e_cri',v1='".SQL_escape($color_e_cri)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_e_urg',v1='".SQL_escape($color_e_urg)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_e_imp',v1='".SQL_escape($color_e_imp)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_e_war',v1='".SQL_escape($color_e_war)."'"))&&
    (SQL_query("REPLACE x_na_opt SET cid=0,type=0,opt='color_e_inf',v1='".SQL_escape($color_e_inf)."'"))        
    )
    MsgInfo(x("Global options updated successfully ..."));
  else if (!$error)
    $error=(x("Error while setting global options."));
  if ($error)
    MsgError($error);
  $command="";
}


if ($command=="") {
  if (!$btn_save)
    anomaly_load_options();


    FormStart();
    popup_script("450","500","","no");
    
    echo InputHidden("command","update");

    WinStart(x("Global options"));
    TItem(x("Report email (for internal network):"));
    TItem(Input('report_i_email',$report_i_email,256));
    TNext();
    TItem(x("Report email (for external network):"));
    TItem(Input('report_e_email',$report_e_email,256));
    TNext();
    TItem(x("Report subject:"));
    TItem(Input('report_subject',$report_subject,128));
    TNext();
    TItem(x("Report body header text:"));
    TItem(InputText('report_body_head',$report_body_head,4,60));
    TNext();
    TItem(x("Report body tail text:"));
    TItem(InputText('report_body_tail',$report_body_tail,4,60));

    TNext();
    TItem(x("Clean new incidents [days]:"));
    TItem(Input('clean_new',$clean_new,2));
    TNext();
    TItem(x("Clean other incidents [days]:"));
    TItem(Input('clean_other',$clean_other,4));

    TNext();
    TItem(x("Internal critical severity color:"),"bgcolor=\"#$color_i_cri\"");
    TItem(Input('color_i_cri',$color_i_cri,6).show_listcolor('color_i_cri'));
    TNext();
    TItem(x("Internal urgent severity color:"),"bgcolor=\"#$color_i_urg\"");
    TItem(Input('color_i_urg',$color_i_urg,6).show_listcolor('color_i_urg'));
    TNext();
    TItem(x("Internal important severity color:"),"bgcolor=\"#$color_i_imp\"");
    TItem(Input('color_i_imp',$color_i_imp,6).show_listcolor('color_i_imp'));
    TNext();
    TItem(x("Internal warning severity color:"),"bgcolor=\"#$color_i_war\"");
    TItem(Input('color_i_war',$color_i_war,6).show_listcolor('color_i_war'));
    TNext();
    TItem(x("Internal informational severity color:"),"bgcolor=\"#$color_i_inf\"");
    TItem(Input('color_i_inf',$color_i_inf,6).show_listcolor('color_i_inf'));

    TNext();
    TItem(x("External critical severity color:"),"bgcolor=\"#$color_e_cri\"");
    TItem(Input('color_e_cri',$color_e_cri,6).show_listcolor('color_e_cri'));
    TNext();
    TItem(x("External urgent severity color:"),"bgcolor=\"#$color_e_urg\"");
    TItem(Input('color_e_urg',$color_e_urg,6).show_listcolor('color_e_urg'));
    TNext();
    TItem(x("External important severity color:"),"bgcolor=\"#$color_e_imp\"");
    TItem(Input('color_e_imp',$color_e_imp,6).show_listcolor('color_e_imp'));
    TNext();
    TItem(x("External warning severity color:"),"bgcolor=\"#$color_e_war\"");
    TItem(Input('color_e_war',$color_e_war,6).show_listcolor('color_e_war'));
    TNext();
    TItem(x("External informational severity color:"),"bgcolor=\"#$color_e_inf\"");
    TItem(Input('color_e_inf',$color_e_inf,6).show_listcolor('color_e_inf'));

    TNext();
    TItem("<br/><br/>".InputSubmit("btn_save",x("Save setting")),'align="center" colspan="2"');
    FormEnd();

}

MenuEnd();
PageTail();




/*  F U N C T I O N S  */



function MySubMenu() {
  global $command,$cid;
  if ($command=="module" || $command=="modulesave")
    $mysubmenu[]=array('caption'=>x("Edit collector"),'url'=>"anomaly.php?command=coll&cid=$cid");
  $mysubmenu[]=array('caption'=>x("Global"),'url'=>'anomaly_glb.php');
  $mysubmenu[]=array('caption'=>x("Collectors"),'url'=>'anomaly.php');
  $mysubmenu[]=array('caption'=>x("Exclusions"),'url'=>'anomaly_exl.php');
  MenuSub(x("Anomalies"),$mysubmenu);
}

function chkclr($color) {
  if (strlen($color)!=6)
    return 1;
  return preg_match("#[0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]#i",$color);
}


?>